sha1_file: be paranoid when creating loose objects
[git/gitweb.git] / t / test-lib.sh
blobafd3053f96b789a73274217b384d245583500c04
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
6 # if --tee was passed, write the output not only to the terminal, but
7 # additionally to the file test-results/$BASENAME.out, too.
8 case "$GIT_TEST_TEE_STARTED, $* " in
9 done,*)
10 # do not redirect again
12 *' --tee '*|*' --va'*)
13 mkdir -p test-results
14 BASE=test-results/$(basename "$0" .sh)
15 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
16 echo $? > $BASE.exit) | tee $BASE.out
17 test "$(cat $BASE.exit)" = 0
18 exit
20 esac
22 # Keep the original TERM for say_color
23 ORIGINAL_TERM=$TERM
25 # For repeatability, reset the environment to known value.
26 LANG=C
27 LC_ALL=C
28 PAGER=cat
29 TZ=UTC
30 TERM=dumb
31 export LANG LC_ALL PAGER TERM TZ
32 EDITOR=:
33 unset VISUAL
34 unset GIT_EDITOR
35 unset AUTHOR_DATE
36 unset AUTHOR_EMAIL
37 unset AUTHOR_NAME
38 unset COMMIT_AUTHOR_EMAIL
39 unset COMMIT_AUTHOR_NAME
40 unset EMAIL
41 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
42 unset GIT_AUTHOR_DATE
43 GIT_AUTHOR_EMAIL=author@example.com
44 GIT_AUTHOR_NAME='A U Thor'
45 unset GIT_COMMITTER_DATE
46 GIT_COMMITTER_EMAIL=committer@example.com
47 GIT_COMMITTER_NAME='C O Mitter'
48 unset GIT_DIFF_OPTS
49 unset GIT_DIR
50 unset GIT_WORK_TREE
51 unset GIT_EXTERNAL_DIFF
52 unset GIT_INDEX_FILE
53 unset GIT_OBJECT_DIRECTORY
54 unset GIT_CEILING_DIRECTORIES
55 unset SHA1_FILE_DIRECTORIES
56 unset SHA1_FILE_DIRECTORY
57 GIT_MERGE_VERBOSITY=5
58 export GIT_MERGE_VERBOSITY
59 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
60 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
61 export EDITOR
62 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
64 # Protect ourselves from common misconfiguration to export
65 # CDPATH into the environment
66 unset CDPATH
68 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
69 1|2|true)
70 echo "* warning: Some tests will not work if GIT_TRACE" \
71 "is set as to trace on STDERR ! *"
72 echo "* warning: Please set GIT_TRACE to something" \
73 "other than 1, 2 or true ! *"
75 esac
77 # Convenience
79 # A regexp to match 5 and 40 hexdigits
80 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
81 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
83 # Each test should start with something like this, after copyright notices:
85 # test_description='Description of this test...
86 # This test checks if command xyzzy does the right thing...
87 # '
88 # . ./test-lib.sh
89 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
90 TERM=$ORIGINAL_TERM &&
91 export TERM &&
92 [ -t 1 ] &&
93 tput bold >/dev/null 2>&1 &&
94 tput setaf 1 >/dev/null 2>&1 &&
95 tput sgr0 >/dev/null 2>&1
96 ) &&
97 color=t
99 while test "$#" -ne 0
101 case "$1" in
102 -d|--d|--de|--deb|--debu|--debug)
103 debug=t; shift ;;
104 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
105 immediate=t; shift ;;
106 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
107 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
108 -h|--h|--he|--hel|--help)
109 help=t; shift ;;
110 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
111 verbose=t; shift ;;
112 -q|--q|--qu|--qui|--quie|--quiet)
113 quiet=t; shift ;;
114 --with-dashes)
115 with_dashes=t; shift ;;
116 --no-color)
117 color=; shift ;;
118 --no-python)
119 # noop now...
120 shift ;;
121 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
122 valgrind=t; verbose=t; shift ;;
123 --tee)
124 shift ;; # was handled already
125 --root=*)
126 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
127 shift ;;
129 echo "error: unknown test option '$1'" >&2; exit 1 ;;
130 esac
131 done
133 if test -n "$color"; then
134 say_color () {
136 TERM=$ORIGINAL_TERM
137 export TERM
138 case "$1" in
139 error) tput bold; tput setaf 1;; # bold red
140 skip) tput bold; tput setaf 2;; # bold green
141 pass) tput setaf 2;; # green
142 info) tput setaf 3;; # brown
143 *) test -n "$quiet" && return;;
144 esac
145 shift
146 printf "* %s" "$*"
147 tput sgr0
148 echo
151 else
152 say_color() {
153 test -z "$1" && test -n "$quiet" && return
154 shift
155 echo "* $*"
159 error () {
160 say_color error "error: $*"
161 GIT_EXIT_OK=t
162 exit 1
165 say () {
166 say_color info "$*"
169 test "${test_description}" != "" ||
170 error "Test script did not set test_description."
172 if test "$help" = "t"
173 then
174 echo "$test_description"
175 exit 0
178 exec 5>&1
179 if test "$verbose" = "t"
180 then
181 exec 4>&2 3>&1
182 else
183 exec 4>/dev/null 3>/dev/null
186 test_failure=0
187 test_count=0
188 test_fixed=0
189 test_broken=0
190 test_success=0
192 die () {
193 code=$?
194 if test -n "$GIT_EXIT_OK"
195 then
196 exit $code
197 else
198 echo >&5 "FATAL: Unexpected exit with code $code"
199 exit 1
203 GIT_EXIT_OK=
204 trap 'die' EXIT
206 # The semantics of the editor variables are that of invoking
207 # sh -c "$EDITOR \"$@\"" files ...
209 # If our trash directory contains shell metacharacters, they will be
210 # interpreted if we just set $EDITOR directly, so do a little dance with
211 # environment variables to work around this.
213 # In particular, quoting isn't enough, as the path may contain the same quote
214 # that we're using.
215 test_set_editor () {
216 FAKE_EDITOR="$1"
217 export FAKE_EDITOR
218 EDITOR='"$FAKE_EDITOR"'
219 export EDITOR
222 test_decode_color () {
223 sed -e 's/.\[1m/<WHITE>/g' \
224 -e 's/.\[31m/<RED>/g' \
225 -e 's/.\[32m/<GREEN>/g' \
226 -e 's/.\[33m/<YELLOW>/g' \
227 -e 's/.\[34m/<BLUE>/g' \
228 -e 's/.\[35m/<MAGENTA>/g' \
229 -e 's/.\[36m/<CYAN>/g' \
230 -e 's/.\[m/<RESET>/g'
233 q_to_nul () {
234 perl -pe 'y/Q/\000/'
237 q_to_cr () {
238 tr Q '\015'
241 append_cr () {
242 sed -e 's/$/Q/' | tr Q '\015'
245 remove_cr () {
246 tr '\015' Q | sed -e 's/Q$//'
249 test_tick () {
250 if test -z "${test_tick+set}"
251 then
252 test_tick=1112911993
253 else
254 test_tick=$(($test_tick + 60))
256 GIT_COMMITTER_DATE="$test_tick -0700"
257 GIT_AUTHOR_DATE="$test_tick -0700"
258 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
261 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
263 # This will commit a file with the given contents and the given commit
264 # message. It will also add a tag with <message> as name.
266 # Both <file> and <contents> default to <message>.
268 test_commit () {
269 file=${2:-"$1.t"}
270 echo "${3-$1}" > "$file" &&
271 git add "$file" &&
272 test_tick &&
273 git commit -m "$1" &&
274 git tag "$1"
277 # Call test_merge with the arguments "<message> <commit>", where <commit>
278 # can be a tag pointing to the commit-to-merge.
280 test_merge () {
281 test_tick &&
282 git merge -m "$1" "$2" &&
283 git tag "$1"
286 # This function helps systems where core.filemode=false is set.
287 # Use it instead of plain 'chmod +x' to set or unset the executable bit
288 # of a file in the working directory and add it to the index.
290 test_chmod () {
291 chmod "$@" &&
292 git update-index --add "--chmod=$@"
295 # Use test_set_prereq to tell that a particular prerequisite is available.
296 # The prerequisite can later be checked for in two ways:
298 # - Explicitly using test_have_prereq.
300 # - Implicitly by specifying the prerequisite tag in the calls to
301 # test_expect_{success,failure,code}.
303 # The single parameter is the prerequisite tag (a simple word, in all
304 # capital letters by convention).
306 test_set_prereq () {
307 satisfied="$satisfied$1 "
309 satisfied=" "
311 test_have_prereq () {
312 case $satisfied in
313 *" $1 "*)
314 : yes, have it ;;
316 ! : nope ;;
317 esac
320 # You are not expected to call test_ok_ and test_failure_ directly, use
321 # the text_expect_* functions instead.
323 test_ok_ () {
324 test_success=$(($test_success + 1))
325 say_color "" " ok $test_count: $@"
328 test_failure_ () {
329 test_failure=$(($test_failure + 1))
330 say_color error "FAIL $test_count: $1"
331 shift
332 echo "$@" | sed -e 's/^/ /'
333 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
336 test_known_broken_ok_ () {
337 test_fixed=$(($test_fixed+1))
338 say_color "" " FIXED $test_count: $@"
341 test_known_broken_failure_ () {
342 test_broken=$(($test_broken+1))
343 say_color skip " still broken $test_count: $@"
346 test_debug () {
347 test "$debug" = "" || eval "$1"
350 test_run_ () {
351 eval >&3 2>&4 "$1"
352 eval_ret="$?"
353 return 0
356 test_skip () {
357 test_count=$(($test_count+1))
358 to_skip=
359 for skp in $GIT_SKIP_TESTS
361 case $this_test.$test_count in
362 $skp)
363 to_skip=t
364 esac
365 done
366 if test -z "$to_skip" && test -n "$prereq" &&
367 ! test_have_prereq "$prereq"
368 then
369 to_skip=t
371 case "$to_skip" in
373 say_color skip >&3 "skipping test: $@"
374 say_color skip "skip $test_count: $1"
375 : true
378 false
380 esac
383 test_expect_failure () {
384 test "$#" = 3 && { prereq=$1; shift; } || prereq=
385 test "$#" = 2 ||
386 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
387 if ! test_skip "$@"
388 then
389 say >&3 "checking known breakage: $2"
390 test_run_ "$2"
391 if [ "$?" = 0 -a "$eval_ret" = 0 ]
392 then
393 test_known_broken_ok_ "$1"
394 else
395 test_known_broken_failure_ "$1"
398 echo >&3 ""
401 test_expect_success () {
402 test "$#" = 3 && { prereq=$1; shift; } || prereq=
403 test "$#" = 2 ||
404 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
405 if ! test_skip "$@"
406 then
407 say >&3 "expecting success: $2"
408 test_run_ "$2"
409 if [ "$?" = 0 -a "$eval_ret" = 0 ]
410 then
411 test_ok_ "$1"
412 else
413 test_failure_ "$@"
416 echo >&3 ""
419 test_expect_code () {
420 test "$#" = 4 && { prereq=$1; shift; } || prereq=
421 test "$#" = 3 ||
422 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
423 if ! test_skip "$@"
424 then
425 say >&3 "expecting exit code $1: $3"
426 test_run_ "$3"
427 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
428 then
429 test_ok_ "$2"
430 else
431 test_failure_ "$@"
434 echo >&3 ""
437 # test_external runs external test scripts that provide continuous
438 # test output about their progress, and succeeds/fails on
439 # zero/non-zero exit code. It outputs the test output on stdout even
440 # in non-verbose mode, and announces the external script with "* run
441 # <n>: ..." before running it. When providing relative paths, keep in
442 # mind that all scripts run in "trash directory".
443 # Usage: test_external description command arguments...
444 # Example: test_external 'Perl API' perl ../path/to/test.pl
445 test_external () {
446 test "$#" = 4 && { prereq=$1; shift; } || prereq=
447 test "$#" = 3 ||
448 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
449 descr="$1"
450 shift
451 if ! test_skip "$descr" "$@"
452 then
453 # Announce the script to reduce confusion about the
454 # test output that follows.
455 say_color "" " run $test_count: $descr ($*)"
456 # Run command; redirect its stderr to &4 as in
457 # test_run_, but keep its stdout on our stdout even in
458 # non-verbose mode.
459 "$@" 2>&4
460 if [ "$?" = 0 ]
461 then
462 test_ok_ "$descr"
463 else
464 test_failure_ "$descr" "$@"
469 # Like test_external, but in addition tests that the command generated
470 # no output on stderr.
471 test_external_without_stderr () {
472 # The temporary file has no (and must have no) security
473 # implications.
474 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
475 stderr="$tmp/git-external-stderr.$$.tmp"
476 test_external "$@" 4> "$stderr"
477 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
478 descr="no stderr: $1"
479 shift
480 say >&3 "expecting no stderr from previous command"
481 if [ ! -s "$stderr" ]; then
482 rm "$stderr"
483 test_ok_ "$descr"
484 else
485 if [ "$verbose" = t ]; then
486 output=`echo; echo Stderr is:; cat "$stderr"`
487 else
488 output=
490 # rm first in case test_failure exits.
491 rm "$stderr"
492 test_failure_ "$descr" "$@" "$output"
496 # This is not among top-level (test_expect_success | test_expect_failure)
497 # but is a prefix that can be used in the test script, like:
499 # test_expect_success 'complain and die' '
500 # do something &&
501 # do something else &&
502 # test_must_fail git checkout ../outerspace
505 # Writing this as "! git checkout ../outerspace" is wrong, because
506 # the failure could be due to a segv. We want a controlled failure.
508 test_must_fail () {
509 "$@"
510 test $? -gt 0 -a $? -le 129 -o $? -gt 192
513 # test_cmp is a helper function to compare actual and expected output.
514 # You can use it like:
516 # test_expect_success 'foo works' '
517 # echo expected >expected &&
518 # foo >actual &&
519 # test_cmp expected actual
522 # This could be written as either "cmp" or "diff -u", but:
523 # - cmp's output is not nearly as easy to read as diff -u
524 # - not all diff versions understand "-u"
526 test_cmp() {
527 $GIT_TEST_CMP "$@"
530 # Most tests can use the created repository, but some may need to create more.
531 # Usage: test_create_repo <directory>
532 test_create_repo () {
533 test "$#" = 1 ||
534 error "bug in the test script: not 1 parameter to test-create-repo"
535 owd=`pwd`
536 repo="$1"
537 mkdir -p "$repo"
538 cd "$repo" || error "Cannot setup test environment"
539 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
540 error "cannot run git init -- have you built things yet?"
541 mv .git/hooks .git/hooks-disabled
542 cd "$owd"
545 test_done () {
546 GIT_EXIT_OK=t
547 test_results_dir="$TEST_DIRECTORY/test-results"
548 mkdir -p "$test_results_dir"
549 test_results_path="$test_results_dir/${0%.sh}-$$"
551 echo "total $test_count" >> $test_results_path
552 echo "success $test_success" >> $test_results_path
553 echo "fixed $test_fixed" >> $test_results_path
554 echo "broken $test_broken" >> $test_results_path
555 echo "failed $test_failure" >> $test_results_path
556 echo "" >> $test_results_path
558 if test "$test_fixed" != 0
559 then
560 say_color pass "fixed $test_fixed known breakage(s)"
562 if test "$test_broken" != 0
563 then
564 say_color error "still have $test_broken known breakage(s)"
565 msg="remaining $(($test_count-$test_broken)) test(s)"
566 else
567 msg="$test_count test(s)"
569 case "$test_failure" in
571 say_color pass "passed all $msg"
573 test -d "$remove_trash" &&
574 cd "$(dirname "$remove_trash")" &&
575 rm -rf "$(basename "$remove_trash")"
577 exit 0 ;;
580 say_color error "failed $test_failure among $msg"
581 exit 1 ;;
583 esac
586 # Test the binaries we have just built. The tests are kept in
587 # t/ subdirectory and are run in 'trash directory' subdirectory.
588 TEST_DIRECTORY=$(pwd)
589 if test -n "$valgrind"
590 then
591 make_symlink () {
592 test -h "$2" &&
593 test "$1" = "$(readlink "$2")" || {
594 # be super paranoid
595 if mkdir "$2".lock
596 then
597 rm -f "$2" &&
598 ln -s "$1" "$2" &&
599 rm -r "$2".lock
600 else
601 while test -d "$2".lock
603 say "Waiting for lock on $2."
604 sleep 1
605 done
610 make_valgrind_symlink () {
611 # handle only executables
612 test -x "$1" || return
614 base=$(basename "$1")
615 symlink_target=$TEST_DIRECTORY/../$base
616 # do not override scripts
617 if test -x "$symlink_target" &&
618 test ! -d "$symlink_target" &&
619 test "#!" != "$(head -c 2 < "$symlink_target")"
620 then
621 symlink_target=../valgrind.sh
623 case "$base" in
624 *.sh|*.perl)
625 symlink_target=../unprocessed-script
626 esac
627 # create the link, or replace it if it is out of date
628 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
631 # override all git executables in TEST_DIRECTORY/..
632 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
633 mkdir -p "$GIT_VALGRIND"/bin
634 for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
636 make_valgrind_symlink $file
637 done
638 OLDIFS=$IFS
639 IFS=:
640 for path in $PATH
642 ls "$path"/git-* 2> /dev/null |
643 while read file
645 make_valgrind_symlink "$file"
646 done
647 done
648 IFS=$OLDIFS
649 PATH=$GIT_VALGRIND/bin:$PATH
650 GIT_EXEC_PATH=$GIT_VALGRIND/bin
651 export GIT_VALGRIND
652 elif test -n "$GIT_TEST_INSTALLED" ; then
653 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
654 error "Cannot run git from $GIT_TEST_INSTALLED."
655 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
656 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
657 else # normal case, use ../bin-wrappers only unless $with_dashes:
658 git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
659 if ! test -x "$git_bin_dir/git" ; then
660 if test -z "$with_dashes" ; then
661 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
663 with_dashes=t
665 PATH="$git_bin_dir:$PATH"
666 GIT_EXEC_PATH=$TEST_DIRECTORY/..
667 if test -n "$with_dashes" ; then
668 PATH="$TEST_DIRECTORY/..:$PATH"
671 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
672 unset GIT_CONFIG
673 GIT_CONFIG_NOSYSTEM=1
674 GIT_CONFIG_NOGLOBAL=1
675 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
677 . ../GIT-BUILD-OPTIONS
679 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
680 export GITPERLLIB
681 test -d ../templates/blt || {
682 error "You haven't built things yet, have you?"
685 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
686 then
687 GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
688 export GITPYTHONLIB
689 test -d ../git_remote_helpers/build || {
690 error "You haven't built git_remote_helpers yet, have you?"
694 if ! test -x ../test-chmtime; then
695 echo >&2 'You need to build test-chmtime:'
696 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
697 exit 1
700 # Test repository
701 test="trash directory.$(basename "$0" .sh)"
702 test -n "$root" && test="$root/$test"
703 case "$test" in
704 /*) TRASH_DIRECTORY="$test" ;;
705 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
706 esac
707 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
708 rm -fr "$test" || {
709 GIT_EXIT_OK=t
710 echo >&5 "FATAL: Cannot prepare test area"
711 exit 1
714 test_create_repo "$test"
715 # Use -P to resolve symlinks in our working directory so that the cwd
716 # in subprocesses like git equals our $PWD (for pathname comparisons).
717 cd -P "$test" || exit 1
719 this_test=${0##*/}
720 this_test=${this_test%%-*}
721 for skp in $GIT_SKIP_TESTS
723 to_skip=
724 for skp in $GIT_SKIP_TESTS
726 case "$this_test" in
727 $skp)
728 to_skip=t
729 esac
730 done
731 case "$to_skip" in
733 say_color skip >&3 "skipping test $this_test altogether"
734 say_color skip "skip all tests in $this_test"
735 test_done
736 esac
737 done
739 # Provide an implementation of the 'yes' utility
740 yes () {
741 if test $# = 0
742 then
744 else
745 y="$*"
748 while echo "$y"
751 done
754 # Fix some commands on Windows
755 case $(uname -s) in
756 *MINGW*)
757 # Windows has its own (incompatible) sort and find
758 sort () {
759 /usr/bin/sort "$@"
761 find () {
762 /usr/bin/find "$@"
764 sum () {
765 md5sum "$@"
767 # git sees Windows-style pwd
768 pwd () {
769 builtin pwd -W
771 # no POSIX permissions
772 # backslashes in pathspec are converted to '/'
773 # exec does not inherit the PID
776 test_set_prereq POSIXPERM
777 test_set_prereq BSLASHPSPEC
778 test_set_prereq EXECKEEPSPID
780 esac
782 test -z "$NO_PERL" && test_set_prereq PERL
783 test -z "$NO_PYTHON" && test_set_prereq PYTHON
785 # test whether the filesystem supports symbolic links
786 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
787 rm -f y